/**********************************************/
/* mqqmobj.cpp ... Queue Mgr obj implement.   */
/* Part of SoftWoehr Library for IBM MQSeries */
/* Copyright *C* 1999 Jack J. Woehr           */
/* PO Box 51, Golden, Colorado 80402-0051     */
/* http://www.well.com/user/jax/SoftWoehr     */
/* jwoehr@ibm.net jax@well.com                */
/* ********************************************/
/* This is open source software. Please see   */
/* file license.txt. THERE IS NO WARRANTY.    */
/**********************************************/
#ifndef SW_MQPRCOBJ_CPP
#define SW_MQPRCOBJ_CPP

#ifndef SW_MQPRCOBJ_HPP
   #include "mqprcobj.hpp"
#endif // SW_MQPRCOBJ_HPP

using namespace std;
using namespace SoftWoehr;

/** Represents a queue */
//class MQProcessDefinition : public MQObject
//   public   :

      /** Create an MQProcessDefinition with the descriptor already set to Queue */
      MQProcessDefinition::MQProcessDefinition() {
         my_descriptor.object_type_process_definition();
         }

      /** Dtor */
      MQProcessDefinition::~MQProcessDefinition() {}

/** Open a given queue manager as an object. */
MQProcessDefinition & MQProcessDefinition::
   open( MQQueueManager & queue_manager
       , const string & object_name
       , const MQObject::Options & options
       )
   {

   /* Instance extra string fields in pre-created descriptor. */
   my_descriptor.set_object_name(object_name);
   /*  If ObjectType is MQOT_Q_MGR, special rules apply; in this case the name must be entirely blank up */
   /*     to the first null character or the end of the field. */
   /*   -  1.4.4 in MQSeries App Prg Ref */

   my_descriptor.set_object_queue_manager_name(queue_manager.get_name());

   MQObject::open( queue_manager // sets my_queue_manager from passed-in
                 , my_descriptor // already filled out
                 , options       // passed in
                 )
                 ;

   return *this;
   } /* MQQueue & MQProcessDefinition::open( MQQueueManager & queue_manager*/
     /*               , string         & queue_name */
     /*               , MQObject::Options & options */
     /*               )   */

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* The code within these blocks was autogenerated.   */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */

/** Character attribute factory for MQCA_APPL_ID */
MQInquiry::character_attribute *
   MQProcessDefinition::mqca_appl_id(void) {
      return new MQInquiry::character_attribute
         ( MQCA_APPL_ID
         , MQ_PROCESS_APPL_ID_LENGTH
         ,"MQCA_APPL_ID // Application identifier"
         )
         ;
         }
/** Character attribute factory for MQCA_ENV_DATA */
MQInquiry::character_attribute *
   MQProcessDefinition::mqca_env_data(void) {
      return new MQInquiry::character_attribute
         ( MQCA_ENV_DATA
         , MQ_PROCESS_ENV_DATA_LENGTH
         ,"MQCA_ENV_DATA // Environment data"
         )
         ;
         }
/** Character attribute factory for MQCA_PROCESS_DESC */
MQInquiry::character_attribute *
   MQProcessDefinition::mqca_process_desc(void) {
      return new MQInquiry::character_attribute
         ( MQCA_PROCESS_DESC
         , MQ_PROCESS_DESC_LENGTH
         ,"MQCA_PROCESS_DESC // Description of process definition"
         )
         ;
         }
/** Character attribute factory for MQCA_PROCESS_NAME */
MQInquiry::character_attribute *
   MQProcessDefinition::mqca_process_name(void) {
      return new MQInquiry::character_attribute
         ( MQCA_PROCESS_NAME
         , MQ_PROCESS_NAME_LENGTH
         ,"MQCA_PROCESS_NAME // Name of process definition"
         )
         ;
         }
/** Character attribute factory for MQCA_USER_DATA */
MQInquiry::character_attribute *
   MQProcessDefinition::mqca_user_data(void) {
      return new MQInquiry::character_attribute
         ( MQCA_USER_DATA
         , MQ_PROCESS_USER_DATA_LENGTH
         ,"MQCA_USER_DATA // User data"
         )
         ;
         }
/** Integer attribute factory for MQIA_APPL_TYPE */
MQInquiry::integer_attribute *
   MQProcessDefinition::mqia_appl_type(void) {
      return new MQInquiry::integer_attribute
         ( MQIA_APPL_TYPE
         ,"MQIA_APPL_TYPE // Application type."
         )
         ;
         }

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* End of autogenerated code.                        */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/** Compose an inquiry which applies to any proc def.
  * Ask everything you can MQINQ about a proc def
  */
MQInquiry * MQProcessDefinition::inquiry_any_process_definition(void) {
   MQInquiry *pmqi = new MQInquiry;
   pmqi->add (mqca_appl_id());
   pmqi->add (mqca_env_data());
   pmqi->add (mqca_process_desc());
   pmqi->add (mqca_process_name());
   pmqi->add (mqca_user_data());
   pmqi->add (mqia_appl_type());
   return pmqi;
   }

#endif                                 /* SW_MQPRCOBJ_CPP           */
